/*****************************************************************************
*
* Copyright (C) 2015 Diwell Electronics Co.,Ltd.
* MODEL : DTPML-SPI series Master
* Version 1.0 (2015.10.20)
* FCPU : 8Mhz 
* MCU : ATMEGA128L. 3.3V  


 1 . Ʒ ڵ ý Ŭ  8Mhz Դϴ.

 2. 5V MCUʹ   ñ ٶϴ.  MCU 3.3V   ּ.


 .

1.  µ  µ   UART0    
   UART0   : 19200bps, 8bit, stop1bit, 帧.

   PC : USB2UART      ͹̳ â  ǽð µ öɴϴ.


2.  ġ     (ġ  ʿ) 
    Ʈ PD0   tact ġ  մϴ.
   Ǯ ܺ Ǯ  ʿ  ġ ݴ ׶ ϸ ˴ϴ.
   
3.     1   setup time  ٸ   ϼ. 


****************************************************************************/

#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h>
#include "delay_loop.h"
#include "UART0.h"

#define CS_HIGH	PORTB |=0x01;		// SCE 1
#define CS_LOW	PORTB &=0xFE;		// SCE 0
#define TARGET_CMD	0xA0			//  µ Ŀǵ
#define SENSOR_CMD	0xA1			//  µ Ŀǵ 
#define LASER_CMD	0xA4			//  Ŀǵ 

#define	ON	1

int	iTARGET, iSENSOR;				// ȣ 2byte µ   
char cTARGET[14], cSENSOR[14];		
unsigned char LASER_COMMAND=0;		//  Ŀǵ ÷ 
unsigned char dummy;

void SPI_MasterTransmit(char cData);
int SEND_COMMAND(unsigned char cCMD);
void DataOutput_UART0(void);

static int Putchar(char cDatum, FILE *stream) 
{
    UartTx(cDatum);
    return 0;
}

ISR(INT0_vect)				// INT0 ͷƮ ƾ 
{
	EIMSK = 0x00;			// INT0 ͷƮ Disable
	LASER_COMMAND = ON;		//    ÷ 
}

int main(void)
{


	Device_Init();			// INT0, UART, SPI ʱȭ 
	
	CS_HIGH;				// CS High Level
	_delay_ms(200);			//  setup ð wait
	_delay_ms(200);	
	_delay_ms(200);	
	_delay_ms(200);	
	EIFR |= 0x01;
	EIMSK = 0x01;			// INT0 ͷƮ    
	sei();					// ü ͷƮ Enable

	
	while(1)
	{

		iTARGET = SEND_COMMAND(TARGET_CMD);			//  µ Read 

		_delay_10us();								// 10us :     

		iSENSOR = SEND_COMMAND(SENSOR_CMD);			//  µ Read

		_delay_ms(20);								// 20ms :    .

		DataOutput_UART0();
		
		if(LASER_COMMAND == ON)
		{
			LASER_COMMAND = 0;
			SEND_COMMAND(0xA4);	//  ON  	
			EIFR |= 0x01;		// ÷ Ŭ 
			EIMSK = 0x01;		// INT0 ͷƮ Enable 
		}
	}
	return 0;
}

void INT0_Init(void)	
{
	PORTD=0x01;				//  Ǯ 
	DDRD = 0x00;
	EICRA = 0x02;			// ϰ  
	EIMSK = 0x00;			// INT0 ͷƮ Ҵ  
}
void SPI_MasterInit(void)
{
	PORTB = 0xff;
	DDRB = 0x07;	//MISO(PB3): INPUT // MOSI(PB2) : OUTPUT //SCK(PB1) : OUTPUT // PB0( SCE ) : OUTPUT
	SPCR = 0x5d;
	SPSR = 0x01;
}
void Device_Init(void) 
{
	INT0_Init();
    Uart_Init();
    fdevopen(Putchar,0);
	SPI_MasterInit();		// SPI ʱȭ 
}

void SPI_MasterTransmit(char cData)
{
	/* Start transmission */
	SPDR = cData;
	/* Wait for transmission complete */
	while(!(SPSR & (1<<SPIF)))
;
}

void DataOutput_UART0(void)
{
	if(iTARGET>=0){sprintf(cTARGET,"Target:%d.%d  ",iTARGET/10, iTARGET%10);}
	else{iTARGET=-iTARGET;sprintf(cTARGET,"Target:-%d.%d  ",iTARGET/10, iTARGET%10);}
	if(iSENSOR>=0){sprintf(cSENSOR, "Sensor:%d.%d\n\r",iSENSOR/10, iSENSOR%10);}
	else{iSENSOR=-iSENSOR;sprintf(cSENSOR, "Sensor:-%d.%d\n\r",iSENSOR/10, iSENSOR%10);}

	printf(cTARGET);
	printf(cSENSOR);
}
int SEND_COMMAND(unsigned char cCMD)
{
	unsigned char Low_Byte, High_Byte;

	CS_LOW;						// SCE LOW

	_delay_10us();				// delay 10us

	SPI_MasterTransmit(cCMD);	// Send 1st Byte
	dummy = SPDR;				// ù  dummy ó

	_delay_10us();				// delay 10us

	SPI_MasterTransmit(0x00);	// Send 2nd Byte
	Low_Byte = SPDR;			//  Ʈ  

	_delay_10us();

	SPI_MasterTransmit(0x00);	// Send 3rd Byte
	High_Byte = SPDR;			//  Ʈ  

	CS_HIGH;					// SCE HIGH

	return (High_Byte<<8 | Low_Byte);	// ,  Ʈ  
}
